#include "include/cpu_info.h"

// static struct cpu_info ci[CPU_NR+1];

static void get_cpu_nr_info(int nr) {
  JUMP_A_WORD;
  JUMP_A_WORD;
  ci[nr].usr = READ_FLOAT;
  JUMP_A_WORD;
  ci[nr].sys = READ_FLOAT;
  ci[nr].iowait = READ_FLOAT;
  JUMP_A_WORD;
  ci[nr].hard_irq = READ_FLOAT;
  ci[nr].soft_irq = READ_FLOAT;
  JUMP_A_WORD;
  ci[nr].idle = READ_FLOAT;
  JUMP_A_CHAR;  /* jump a newline */
}

/*
 * Get each CPU and average CPU information
 * each CPU information be placed at ci[0~CPU_NR-1]
 * average CPU information be placed at ci[CPU_NR]
 */
void get_cpu_info() {
  scanf("%s", times);
  JUMP_A_LINE;
  int i;
  get_cpu_nr_info(CPU_ALL);
  for (i = 0; i < CPU_NR; ++i)
    get_cpu_nr_info(i);
  JUMP_A_LINE;
}

/*
static void output_cpu_nr_info(int nr) {
  fprintf(file, "%.2f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f\t",
      ci[nr].usr, ci[nr].sys, ci[nr].idle, ci[nr].iowait, 
      ci[nr].hard_irq, ci[nr].soft_irq);
}

void output_cpu_info() {
  output_cpu_nr_info(CPU_ALL);
  int i;
  for (i = 0; i < CPU_NR; ++i)
    output_cpu_nr_info(i);
}
*/
