#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>

MODULE_LICENSE("Dual BSD/GPL");
extern int getlock();
extern int freelock();

static int call_init(void)
{
    printk(KERN_EMERG "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++hello,kernel from call-5\n");
    struct task_struct * ts = current;
    printk("pid = %d\n",ts->pid);
    
    printk(KERN_EMERG "call-5 initialized\n");
    getlock();
    printk(KERN_EMERG "call-5 got the lock!\n");
    return 0;
}

static void call_exit(void)
{
    freelock();
    printk(KERN_EMERG "call-5 free the lock!\n");
    printk(KERN_EMERG "goodbye,kernel from call-5\n");
}

module_init(call_init);
module_exit(call_exit);

MODULE_AUTHOR("edsionte Wu");
MODULE_DESCRIPTION("This is a simple example!\n");
MODULE_ALIAS("A simplest example");
