#include <stdio.h>
#include <stdlib.h>

int main(void) {
  const size_t kAllocSize = 4096*1024;
  int alloc = 0, i;
  char* p = NULL;
  while (p = (char*)malloc(kAllocSize)) {
    ++alloc;
    for (i = 0; i < kAllocSize; ++i) {
      p[i] = 'a' + (alloc+i)%26;
    }
    printf("alloc=%dMb, *p=%c\n", alloc<<2, p[0]);
    //sleep(1);
  }
  printf("The maxmium allocate memory size: %uB, %dMb\n",
    kAllocSize*alloc, alloc<<2);
  return 0;
}

