#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>

MODULE_LICENSE("Dual BSD/GPL");
DEFINE_SPINLOCK(lock);
int getlock()
{
    spin_lock(&lock);
    return 1;
}

int getlocksleep()
{
    spin_lock(&lock);
    ssleep(1200);
    return 1;
}

int freelock()
{
    spin_unlock(&lock);
}
static int hello_init(void)
{
    printk(KERN_EMERG "hello,kernel-----------------------------------------------------------------------------------\n");
    struct task_struct * ts = current;
    printk("pid = %d\n",ts->pid);
    
    printk(KERN_EMERG "lock initialized\n");

  /*printk(KERN_EMERG "###########################################get lock and sleep\n");
    getlocksleep();
    freelock();
    printk(KERN_EMERG "############################################free lock and wake up\n");
    */
    return 0;
}





static void hello_exit(void)
{
    printk(KERN_EMERG "goodbye,kernel\n");
}

EXPORT_SYMBOL(getlock);
EXPORT_SYMBOL(getlocksleep);
EXPORT_SYMBOL(freelock);
module_init(hello_init);
module_exit(hello_exit);

MODULE_AUTHOR("edsionte Wu");
MODULE_DESCRIPTION("This is a simple example!\n");
MODULE_ALIAS("A simplest example");
