#ifndef __IO_INFO_H__
#define __IO_INFO_H__

#include "monitor.h"

#ifdef __IO_INFO_H__
#define MAX_DEV_NR 	8
#define NO_DEV		0
#define MORE_DEV	1
#endif

struct IO_info {
  float blk_rd_per_sec;
  float blk_wr_per_sec;
  struct dev_info {
    float sec_rd_per_sec; 	/* 1 sector = 512 bytes */
    float sec_wr_per_sec;
    float avgqu_len;  		/* average queue length of the requests */
    float await;  		/* average time for I/O requests -> served, ms */
    /* float svctm;  		/* delete */
    float util;   		/* Percentage of CPU time during I/O requests */
  } di[MAX_DEV_NR];
} ioi;

extern void get_blk_info();
extern void get_devIO_info();
/** extern void output_IO_info(); */

#endif  /* __IO_INFO_H__ */

