#ifndef __DETECTOR_H__
#define __DETECTOR_H__

#include "mon_det_comm.h"

/* must be the same as "monitor/include/cpu_info.h" */
#define CPU_NR			4

/* poll process flag */
#define	EXEC_ERROR		(1 << 30)

/* continuously execute time */
#define EXEC_TIMEOUT		200000000

#define MEM_BLK_PROC		32
#define MEM_LOW_BOUND		(128 * 1024)
#define MAX_MEM_OCPY		(512 * 1024)

#define MAX_BLK_PROC		120
#define PER_CPU_MAX_RUN		20
#define TIMEOUT_PANIC		3

enum recover_flag {
  PANIC = 1,
  KILL,
  NMI,
};

#endif /* __DETECTOR_H__ */

