#ifndef __MON_DET_COMM_H__
#define __MON_DET_COMM_H__

/* This file hold the communicated information, must keep complete same as 
 * "monitor/include/mon_det_comm.h". 
 */

#ifndef	CPU_NR
#define	CPU_NR		4
#endif

#define SOCKET_OPS_BASE	128
#define SOCKET_OPS_SET	(SOCKET_OPS_BASE)
#define SOCKET_OPS_GET	(SOCKET_OPS_BASE)
#define SOCKET_OPS_MAX	(SOCKET_OPS_BASE + 1)

#define DET_ALERT	409
#define DET_WAKEUP	425

#define CPU_ERROR	(1 << 29)
#define PROC_ERROR 	(1 << 30)	/* run_proc_num is too much */
#define MEM_ERROR  	(1 << 31)

struct det_msg {
  unsigned int cmd;
  unsigned int error_code;
  struct cpu_t {
    int sys;
    int iowait;
    int usr;
  } c[CPU_NR];
  int run_proc_num;
  int blk_proc_num;
  int kbmemfree;
  int util;
};

#endif /* __MON_DET_COMM_H__ */
