#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/semaphore.h>
#include <linux/spinlock.h>

#include <linux/kthread.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>
#include <linux/interrupt.h>

static struct task_struct* ts;

static int irq_chaos(void* unused) {
  msleep(1500);
  for(;;) {
    local_irq_disable();
    int i;
    for(i=0;i<10;i++) {long k=9999.8; k=k*(k+3.7)*k;k=k/2.13;}
    local_irq_enable();
  }
  return 0;
}

static int __init hello_init(void)
{
    printk(KERN_EMERG "1111111111---------------------------------hello,kernel\n");
    /* set core affinity to CPU 1*/
    ts = kthread_create(irq_chaos, NULL, "irq_chaos");
    kthread_bind(ts, 1);
    wake_up_process(ts);
    printk(KERN_EMERG "### unlock 1\n");
    return 0;
}

static void __exit hello_exit(void)
{
    kthread_stop(ts);
    local_irq_enable();
    printk(KERN_EMERG "irq_chaos: goodbye,kernel\n");
}

MODULE_LICENSE("Dual BSD/GPL");
module_init(hello_init);
module_exit(hello_exit);

