#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/thread_info.h>
#include <linux/kthread.h>
MODULE_LICENSE("Dual BSD/GPL");
extern int getlock();
extern int freelock();

static struct task_struct* ts;
static int call_init(void)
{
    printk(KERN_EMERG "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++hello,kernel from call-1\n");
    ts = kthread_create(getlock, NULL, "getlock1");
    kthread_bind(ts, 1);
    wake_up_process(ts);
  //  printk(KERN_EMERG "### unlock 2\n");
    return 0;
}

static void call_exit(void)
{
    freelock();
    printk(KERN_EMERG "call-1 free the lock!\n");
    printk(KERN_EMERG "goodbye,kernel from call-1\n");
}

module_init(call_init);
module_exit(call_exit);

MODULE_AUTHOR("edsionte Wu");
MODULE_DESCRIPTION("This is a simple example!\n");
MODULE_ALIAS("A simplest example");
