#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/semaphore.h>

MODULE_LICENSE("Dual BSD/GPL");

DEFINE_SEMAPHORE(sema);

static int down_init(void) {
  printk(KERN_EMERG "down 1\n");
  down(&sema);
  printk(KERN_EMERG "down 2\n");
  down(&sema);

  return 0;
}

static void down_exit(void) {
  printk(KERN_EMERG "goodbye,up\n");
}

module_init(down_init);
module_exit(down_exit);

