#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

extern void down_sema(void);
extern void up_sema(void);

static int down_init(void) {
  printk(KERN_EMERG "+++++++++++++++++++++++++++come down\n");
  down_sema();
  printk(KERN_EMERG "+++++++++++++++++++++++++++down succesfully!\n");
  return 0;
}

static void down_exit(void) {
  up_sema();
  printk(KERN_EMERG "down up the sema!\n");
  printk(KERN_EMERG "goodbye,kernel from down\n");
}

module_init(down_init);
module_exit(down_exit);

MODULE_LICENSE("Dual BSD/GPL");

