// infinite loop when module initialize
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

MODULE_LICENSE("Dual BSD/GPL");

static int __init loop_init(void) {
  printk(KERN_EMERG "Loop start!\n");
  for (;;) {}
  return 0;
}

static void __exit loop_exit(void) {
  printk(KERN_EMERG "Loop out.\n");
}

module_init(loop_init);
module_exit(loop_exit);

