#ifndef __CPU_INFO_H__
#define __CPU_INFO_H__

#include "monitor.h"

#ifdef __CPU_INFO_H__
#define CPU_NR 		4
#define CPU_ALL 	CPU_NR
#endif

struct cpu_info {
  float usr;  /* percentage of time spent by application */
  float sys;  /* percentage of time spent by systemcall & exception */
  float idle; /* percentage of time spent by idle, not disk I/O wait */
  float iowait;   /* percentage of time spent by disk I/O wait */
  float hard_irq; /* percentage of time spent by hard irq */
  float soft_irq; /* percentage of time spent by soft irq */
} ci[CPU_NR+1];

extern void get_cpu_info();
/* extern void output_cpu_info(); */

#endif /* __CPU_INFO_H__ */

