#ifndef __MEM_INFO__
#define __MEM_INFO__

#include "monitor.h"

struct mem_info {
  int kbmemfree;  /* delete */
  int kbmemused;
  int kbbuffers;
  /* int kbcached; */
  /* int kbcommit;  /* memory in kilobytes needed for current workload */
  int kbswpfree; /* delete */
  int kbswpused;
  float free_pg_per_sec;    /* free page per second */
  /* float add_bufpg_per_sec;  /* add buffer page per second */
  /* float add_capg_per_sec;   /* add cache page per second */
  float pswpin_per_sec;
  float pswpout_per_sec;
  float pgin_per_sec;
  float pgout_per_sec;
  /* float fault_per_sec; */
} mi;

extern void get_swap_info();
extern void get_paging_info();
extern void get_memstatis_info();
extern void get_memutil_info();
extern void get_swaputil_info();
/** extern void output_mem_info(); */

#endif /* __MEM_INFO__ */

