#ifndef	__MONITOR_H__
#define __MONITOR_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <signal.h>

#define MAXLEN 		256
#define TIMELEN 	32
extern char buffer[];
extern char times[];
extern FILE* file;

#define JUMP_A_CHAR	getchar()
#define JUMP_A_WORD	scanf("%s", buffer)
#define JUMP_A_LINE	fgets(buffer, MAXLEN, stdin)
#define READ_FLOAT 	(scanf("%s", buffer), (float)atof(buffer))
#define READ_INT   	(scanf("%s", buffer), atoi(buffer))
#define NEWLINE		do { \
			  fputc('\n', file); \
			  fflush(file); \
			} while(0)

#endif /* __MONITOR_H__ */

