#ifndef __PROC_H__
#define __PROC_H__

#include "monitor.h"

struct proc_info {
  /* int proc_num;     /* number of all current processes */
  int run_proc_num; /* number of TASK_RUNNING */
  int blk_proc_num; /* number of [UN]INTERRUPTABLE */
  float fork_per_sec;
  float cs_per_sec; /* context switch times per second */
} pi;

extern void get_proc_info();
extern void get_task_info();
extern void output_proc_info();

#endif /* __PROC_H__ */

