#include "include/mem_info.h"

/** static struct mem_info mi; */

void get_swap_info() {
  JUMP_A_LINE;
  JUMP_A_WORD;
  mi.pswpin_per_sec = READ_FLOAT;
  mi.pswpout_per_sec = READ_FLOAT;
  JUMP_A_CHAR;  /* jump a newline */
  JUMP_A_LINE;
}

void get_paging_info() {
  /* to be complete */
  JUMP_A_LINE;
  JUMP_A_WORD;
  mi.pgin_per_sec = READ_FLOAT;
  mi.pgout_per_sec = READ_FLOAT;
  JUMP_A_WORD; /* mi.fault_per_sec = READ_FLOAT; */
  JUMP_A_LINE;
  JUMP_A_LINE;
}

void get_memstatis_info() {
  JUMP_A_LINE;
  JUMP_A_WORD;
  mi.free_pg_per_sec = READ_FLOAT;
  JUMP_A_WORD; /* mi.add_bufpg_per_sec = READ_FLOAT; */
  JUMP_A_WORD; /* mi.add_capg_per_sec = READ_FLOAT; */
  JUMP_A_CHAR;
  JUMP_A_LINE;
}

void get_memutil_info() {
  /* to be complete */
  JUMP_A_LINE;
  JUMP_A_WORD;
  mi.kbmemfree = READ_INT;
  mi.kbmemused = READ_INT;
  JUMP_A_WORD;
  mi.kbbuffers = READ_INT;
  JUMP_A_WORD; /* mi.kbcached = READ_INT; */
  JUMP_A_WORD; /* mi.kbcommit = READ_INT; */
  JUMP_A_LINE;
  JUMP_A_LINE;
}

void get_swaputil_info() {
  JUMP_A_LINE;
  JUMP_A_WORD;
  mi.kbswpfree = READ_INT;
  mi.kbswpused = READ_INT;
  JUMP_A_LINE;
  JUMP_A_LINE;
}

/**
void output_mem_info() {
  fprintf(file, "%d\t%d\t%d\t%d\t%d\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f\t",
      mi.kbmemfree, mi.kbmemused, mi.kbbuffers, mi.kbswpfree, mi.kbswpused,
      mi.free_pg_per_sec, mi.swpin_per_sec, mi.swpout_per_sec, 
      mi.pgin_per_sec, mi.pgout_per_sec);
}
*/

